#
# SevoMod  (by Sevo, duh!)
# CvSevoEventManager
# 

from CvPythonExtensions import *
import CvUtil

import CvEventManager
import sys
import PyHelpers

import SevoMod

gc = CyGlobalContext()	

RIM = SevoMod.ReInitInterceptorMision()
cd = SevoMod.CulturalDecay()
rf = SevoMod.RealFort()
tc = SevoMod.TechConquest()
hu = SevoMod.HeroicUnits()
sa = SevoMod.StackAid()

PyPlayer = PyHelpers.PyPlayer

# globals
###################################################
class CvSevoEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)

	def onBeginGameTurn(self, argsList):
		iGameTurn = argsList[0]
		self.parent.onBeginGameTurn(self, argsList)

	def onUnitMove(self, argsList):
		rf.onUnitMove(argsList)
		self.parent.onUnitMove(self, argsList);
		sa.onUnitMove(argsList)
		
	def onUnitBuilt(self, argsList):
		self.parent.onUnitBuilt(self, argsList);
		sa.onUnitBuilt(argsList)

	def onUnitKilled(self, argsList):
		self.parent.onUnitKilled(self, argsList);
		sa.onUnitKilled(argsList)

	def onLoadGame(self, argsList):
		self.parent.onLoadGame(self, argsList)
		# 12monkeys Mod - Re-Init Interceptor Mission On Load
		# SetValue to True for read below
		RIM.firsttime = true

	def onKbdEvent(self, argsList):
		eventType,key,mx,my,px,py = argsList
		game = CyGame()
		theKey = int(key)
		## 12monkeys - Re-Init Interceptor Mission 
		if (theKey == int(InputTypes.KB_I)) and (self.bShift):
			RIM.doReInit()
			return 1		

		self.parent.onKbdEvent(self, argsList)

	def onTechAcquired(self, argsList):
		rf.onTechAcquired(argsList)
		self.parent.onTechAcquired(self, argsList)

	def onCityAcquired(self, argsList):
		tc.onCityAcquired(argsList)
		self.parent.onCityAcquired(self, argsList)

	def onEndGameTurn(self, argsList):
		cd.onEndGameTurn(argsList)
		self.parent.onEndGameTurn(self, argsList)

	def onBeginPlayerTurn(self, argsList):
		if (RIM.firsttime):
			RIM.doReInit()
			RIM.firsttime = false
		self.parent.onBeginPlayerTurn(self, argsList)

	def onImprovementBuilt(self, argsList):
		rf.onImprovementBuilt(argsList)
			
		'GreenMod change, creates summer forest and winter forest, removes the building newforest'	
		iImprovement, iX, iY = argsList
		pPlot = CyMap().plot(iX,iY)
		if(iImprovement==gc.getInfoTypeForString('IMPROVEMENT_NEW_FOREST_4')):
			CyInterface().addMessage(CyGame().getActivePlayer(),True,15,'Forest has matured!','AS2D_DISCOVERBONUS',1,'Art/Interface/Buttons/TerrainFeatures/Forest.dds',ColorTypes(8),iX,iY,True,True)
			pPlot.setFeatureType(4, 1)
			pPlot.setImprovementType(-1)
		
		self.parent.onImprovementBuilt(self, argsList)

        def onCombatResult(self, argsList):
		'Combat Result'
		self.parent.onCombatResult(self, argsList);
		#INSERT MODS
		hu.onCombatResult(argsList)
